//--------------------------------------------------------------------------------------
// basic vertex and pixel shader

//--------------------------------------------------------------------------------------
// Global variables
//--------------------------------------------------------------------------------------

// transformation matrices
float4x4 mtxWorld;  
float4x4 mtxProj;
float4x4 mtxLight;

//--------------------------------------------------------------------------------------
// Vertex shader output structure
//--------------------------------------------------------------------------------------

struct VS_INPUT
{
	float4 Pos       : POSITION;
	
};

struct VS_OUTPUT
{
	float4 Pos		  : POSITION;
	float2 Depth	  : TEXCOORD0;
	
};


//--------------------------------------------------------------------------------------
// Vertex shader
//--------------------------------------------------------------------------------------
VS_OUTPUT VtxShader( VS_INPUT In )
{
    VS_OUTPUT Out;

	// position xform using ligh
	In.Pos   = mul(In.Pos, mtxWorld);
	In.Pos   = mul(In.Pos, mtxLight);
	Out.Pos   = mul(In.Pos, mtxProj);
		
	Out.Depth = float2( Out.Pos.z, Out.Pos.w );	
		
    return Out;    
}

//--------------------------------------------------------------------------------------
// Pixel shader
//--------------------------------------------------------------------------------------
float4 PixShader(VS_OUTPUT In) : COLOR
{ 
	return ( In.Depth.x / In.Depth.y ); // z/w
}

//---------------------------------------------------------------------------------------

technique getDepth
{
    pass P0
    { 
        VertexShader = compile vs_2_0 VtxShader( );
		PixelShader  = compile ps_2_0 PixShader( );          
    }
}
//---------------------------------------------------------------------------------------